/*
	File name:	bmorph.h
	Type:		C include file
	Author:		Gang Liu
	Date:		10/14/96
	Function:	Define some data structures and declare the prototype
			of some binary morphological utilities.
*/
#ifndef	_bmorph_h_
#define	_bmorph_h_

typedef	struct {
	short	width, height;	/* size of the structuring element */
	short	x, y;		/* origin of the structuring element */
	char	**SE;
} BSE;	/* Binary Structuring Element */

int	block_SE(int width, int heitht, int cen_x, int cen_y, BSE *se);
int	disk_SE(int width, int heitht, int cen_x, int cen_y, float R, BSE *se);
int	line_SE(int width, int height, int cen_x, int cen_y,
		int x1, int y1, int x2, int y2, BSE *se);
void	free_SE(BSE *se);

void	bdilation(unsigned char **inimage, int width, int height,
		unsigned char fg, unsigned char bg,
		BSE *se, unsigned char **outimage);
void	berosion(unsigned char **inimage, int width, int height,
		unsigned char fg, unsigned char bg,
		BSE *se, unsigned char **outimage);
void	bopen(unsigned char **inimage, int width, int height,
		unsigned char fg, unsigned char bg,
		BSE *se, unsigned char **outimage);
void	bclose(unsigned char **inimage, int width, int height,
		unsigned char fg, unsigned char bg,
		BSE *se, unsigned char **outimage);

long	bcardinality(unsigned char **image, int width, int height,
		unsigned char fg, unsigned char bg);
void	bcomplement(unsigned char **image, int width, int height,
		unsigned char fg, unsigned char bg);
void	bunion(unsigned char **image1, int width, int height,
		unsigned char fg, unsigned char bg,
		unsigned char **image2);
void	bintersection(unsigned char **image1, int width, int height,
		unsigned char fg, unsigned char bg,
		unsigned char **image2);
void	bsubtraction(unsigned char **image1, int width, int height,
		unsigned char fg, unsigned char bg,
		unsigned char **image2);

#endif
