#!/bin/sh

usage()
{
echo "Usage: $0 <PGM data> <PGM mask> <color> <output PPM>"
echo "where <color> can be 'red', 'green', or 'blue'"
}

if ([ $# -lt 4 ])
then
	usage;
	exit 1;
fi
datafile=$1
maskfile=$2
color=$3
out=$4


localmask=foolocalmask.pgm
invmask=fooinvmask.pgm
red=foored.pgm
blue=fooblue.pgm
green=foogreen.pgm

tempfiles="$red $blue $green $localmask $invmask"

rm -f $tmpfiles

arithm b $maskfile $localmask
arithm i $localmask $invmask
arithm m $datafile $invmask $red
arithm m $datafile $invmask $blue
arithm m $datafile $invmask $green

case $color in
red)
	arithm + $red $localmask $red ;;
green)
	arithm + $green $localmask $green ;;
blue)
	arithm + $blue $localmask $blue ;;
*)
	usage ;
	exit 1;;
esac

pgms2ppm $red $green $blue $out

rm $tempfiles
exit 0
